-- $Id: pgsql_geoip2_asn_table.sql 695 2019-08-21 01:38:00Z bhockney $
--
-- Schema for geoip version 2 autonomous system table. See README.geoip for
-- information on using this file.
--
-- the ip4r extension needs to be installed first
-- CREATE EXTENSION IF NOT EXISTS ip4r;

-- Create asns table
CREATE TABLE "asns" (
  "network"                        cidr             NOT NULL,
  "autonomous_system_number"       text             DEFAULT NULL,
  "autonomous_system_organization" text             DEFAULT NULL,
  CONSTRAINT geoip2_asns_pkey PRIMARY KEY (network)
);
CREATE INDEX "geoip2_asns_ip4r_network" ON "asns" USING gist (iprange(network));
-- Always create the gist index on network, above. You can also create indices
-- other column use use for filtering or sorting.
-- CREATE INDEX "geoip2_as_number" ON "asns" (autonomous_system_number);
-- CREATE INDEX "geoip2_as_org"    ON "asns" (autonomous_system_organization);

-- vim: set syntax=sql:
