<?php
/*
$Id: delete_report.php 727 2023-11-16 20:40:20Z bhockney $
(C) 2003-2023 by Bob Hockney <zeus@ix.netcom.com>

confirm deletion of report definitions

This code is distributed under the terms of GNU GPL
*/
?>

<?php
	$link = db("open", "$database");
	if (db("exists", "SELECT count(*) FROM $reports", $link)) {
		if ($FWLOG["report"] == "default") {
			$status = "<span class='err_msg'>\tCANNOT DELETE DEFAULT</span>\n";
			include "include/edit_report.php";
			exit();
		} elseif (db("totalrows", db("statement", "SELECT code FROM $reports "
			."WHERE code='".db("escape", "{$FWLOG["report"]}", $link)."'", $link)) == 0) {
			$status = "Cannot Delete report code {$FWLOG["report"]}.<br>It does not exist!";
			include "include/edit_report.php";
			exit();
		}
	}
	if (isset($FWLOG["delete_report"])) {
		$code = $FWLOG["delete_report"];
		if (db("exists", "SELECT count(*) FROM $reports", $link)) {
			if (db("statement", "DELETE FROM $reports WHERE code = '".db("escape", "$code", $link)."'", $link)) {
				$status = "\tREPORT $code DELETED!\n";
			} else {
				$status = "Couldn't Delete Report '$code'";
			}
			include "include/edit_report.php";
			exit();
		}
	} // End of "delete"
	db("close", $link);
?>

<!DOCTYPE html>
<html lang="en">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>Webfwlog - Delete Report</title>
  <LINK REL=StyleSheet HREF="style.css" TYPE="text/css" MEDIA=screen>
</head>

<body>
	<h1 class="align_center"><?php print "{$config["title"]}"; ?></h1>

<form action="<?php print "$self"; ?>" method="POST">

<?php
	foreach ($FWLOG as $a => $b) {
			if (!($a == "page")
			    and ! ($a == "data_tables"))
			print "<input type='hidden' name=\"".htmlspecialchars("$a", ENT_QUOTES).
				"\" value=\"".htmlspecialchars("$b", ENT_QUOTES)."\">\n";
	}
?>
<input type='hidden' name='page' value='delete'>

<div class="align_center">
<table class="align_table">
  <caption>
     DELETE REPORT DEFINITION<br><br>
	 <?php if (isset($status)) print "$status"; ?>
  </caption>
    <tr>
    	<td class="display_border align_left status_msg" colspan=2>
			<strong>
				<?php
					print "<span class='err_msg'>Deleting {$FWLOG["report"]}:  Are you sure?</span>";
				?>
			</strong>
		</td>
	</tr>
	<tr>
		<td class="display_border align_left save_label">Description:</td>
		<td class="display_border align_left"><?php print htmlspecialchars("{$FWLOG["description"]}"); ?></td>      
    </tr>
    <tr>
      <td class="display_border align_left">Report Code:</td>
      <td class="display_border align_left">
		<input type="hidden" name="delete_report" value="<?php print "{$FWLOG["report"]}"; ?>">
			<?php print "{$FWLOG["report"]}"; ?>
		</td>
    </tr>
    <tr>
    	<td class="display_border align_left" colspan=2>
			<input class="submit" type="submit" name="action" value="Delete">&nbsp;
			<input class="submit" type="submit" name="delete" value="Cancel">
		</td>
	</tr>
</table>
</div>

</form>

</body>
</html>

<!-- vim:set ts=4: -->
