<?php
/*
$Id: edit_report.php 727 2023-11-16 20:40:20Z bhockney $
(C) 2003-2023 by Bob Hockney <zeus@ix.netcom.com>

report editing form for webfwlog

Webfwlog is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
?>
<?php
	$link = db("open", "$database");

	if (!isset($FWLOG["refresh"]))
		$FWLOG["refresh"] = $config["refresh"];

	if (isset($FWLOG["report"])) {
		$code = $FWLOG["report"];
	} else {
		$code = "";
	}

	if (!isset($FWLOG["action"]))
		$FWLOG["action"] = "none";

	switch (strtolower($FWLOG["action"])) {
	
	case "use report":
	if (db("exists", "SELECT count(*) FROM $reports", $link)) {
		$code = '';
		if (isset($FWLOG["select_report"])) $code = $FWLOG["select_report"];
		$rownum = 0;
		$result = db("nextrow", db("statement", "SELECT definition FROM $reports WHERE code ='".db("escape", "$code", $link)."'", $link));
		if (db("exists", "SELECT last_accessed FROM $reports", $link)) {
			db("statement", "UPDATE $reports SET last_accessed = $time WHERE code = '".db("escape", "$code", $link)."'", $link);
		}
		if ("$code" == "<NEW>" or isset($result["definition"])) {
			if (isset($result["definition"]))
				$definition = unserialize($result["definition"]);
			if ("$code" == "<NEW>" or isset($FWLOG["drill_down"])) {
				unset ($FWLOG["action"]);
			} else {
				$FWLOG = $definition;
			}
			if (isset($FWLOG["data_source"]) and $FWLOG["data_source"] == "ulogd")
				$FWLOG["data_source"] = "db";
			if (!isset($FWLOG['data_table']) and isset($FWLOG["ulog_table"])) {
				$FWLOG["data_table"] = $FWLOG["ulog_table"];
				unset ($FWLOG["ulog_table"]);
			}
			if (!isset($FWLOG["data_tables"]) and isset($FWLOG["data_table"]))
				$FWLOG["data_tables"] = preg_split("/ +/", "{$FWLOG["data_table"]}");
			if (isset($FWLOG["show_sql"])) {
				$FWLOG["be_verbose"] = "{$FWLOG["show_sql"]}"; // show_sql is deprecated
				unset ($FWLOG["show_sql"]);
			}
			$FWLOG["report"] = "$code";
			require 'include/orders.php';
			require 'include/edit_report.php';
			return; // Restart edit_report with new definition, so return upon return
		} else {
			$status = "\tReport Not Defined!\n";
		}
	} // End of "use report"
		break;

	case "save as default":
	if (!isset($status) and db("exists", "SELECT count(*) FROM $reports", $link)) {
		$FWLOG = definition_do_not_save($FWLOG);
		unset ($FWLOG["report"]);
		$definition = db("escape", serialize($FWLOG), $link);
		$rownum = 0;
		if (db("nextrow", db("statement", "SELECT code FROM $reports WHERE code ='default'", $link))) {
			if (!db("statement", "UPDATE $reports 
				SET description = '".db("escape", "{$FWLOG["description"]}", $link)."',
					definition  = '$definition'
				WHERE code='default'", $link)
				)
				$status = "\tERROR: REPORT NOT SAVED\n";
		} else {
			if (!db("statement", "INSERT INTO $reports
					(code, description, definition)
					VALUES ('default', '".db("escape", "{$FWLOG["description"]}", $link)."', '$definition')", $link
				))
				$status = "\tERROR: REPORT NOT SAVED\n";
		}
		$status = "\tSETTINGS SAVED AS DEFAULT!\t";
	} else {
		if (isset($status)) $status = "$status<br><span class=err_msg>REPORT NOT SAVED</span>";
	} //End of "save as default"
		break;

	case "create new":
	case "report editor":
	if (db("exists", "SELECT count(*) FROM $reports", $link)) {
		$rownum = 0;
		$result = db("nextrow", db("statement", "SELECT definition FROM $reports WHERE code ='default'", $link));
		if ($result["definition"]) {
			$definition = unserialize($result["definition"]);
			unset($FWLOG);
			$FWLOG = $definition;
			unset ($FWLOG["report"]);
		} else {
			$FWLOG = set_defaults($FWLOG);
			$status = "\tDefault Report Not Defined!\n";
		}
	} else {
		$FWLOG = set_defaults($FWLOG);
	}
	$name = "<NEW>";
	require 'include/orders.php';
	$_SESSION["fwlog"] = $FWLOG;
	 // End of "create new"
		break;

	default:
		 break;
	} // end switch

	$FWLOG = $FWLOG + $options;

	if (!$columns)
		$status = "\t<span class=err_msg>No Columns Selected!</span>\n";

	if (!isset($FWLOG["summarize"])
		and (  isset($FWLOG["c_count"])
			or isset($FWLOG["c_earliest"]) 
			or isset($FWLOG["c_latest"])
			or isset($FWLOG["c_oob_earliest"]) 
			or isset($FWLOG["c_oob_latest"]))) {
		$status = "\t<span class=err_msg> Cannot use grouping column<br>" .
										"if no Summarization!<br>" .
										"i.e., Occurrences,  Earliest,  Local Time ...</span>\n";
	}

	if (isset($FWLOG["summarize"])
		and (  isset($FWLOG["c_local_time"])
			or isset($FWLOG["c_oob_time_sec"]) 
			or isset($FWLOG["c_oob_time_usec"]))) {
		$status = "\t<span class=err_msg> Cannot use date/time column<br>" .
										"if Summarization!<br>" .
										"i.e., Local Time, OOB Time ...</span>\n";
	}

	if (isset($imported)) {
		$status = "Report {$FWLOG["report"]} Imported";
	}

		// Always executes
	$rownum = 0;
	if (!isset($name))
		$name = "$code";

?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>Webfwlog - Edit Report <?php print htmlspecialchars("$name", ENT_QUOTES); ?></title>
  <LINK REL=StyleSheet HREF="style.css" TYPE="text/css">
</head>

<body>
<?php if ($config["debug"]) include "include/debug.php"; ?>

<div class="align_center">
<table class="align_table">
<caption class="align_center title"><?php print "{$config["title"]}"; ?></caption>
<tr>
<td>

<form action="<?php print "$self"; ?>" method="POST">  <!-- Begin of Form -->
<table class="align_left"> <!-- Begin of Main Table -->
<tr>  <!-- Begin of First row -->
	<td class="display_border valign_top_text" rowspan="2" colspan="1"> <!-- Begin of basic report info -->
	<table>
		<tr>
			<td>
				<input
					class="submit"
					type="submit"
					name="action"
					value="Refresh"
					tabindex=1
				>
				<input
					class="submit"
					type="submit"
					name="action"
					value="Run Report"
					tabindex=1
				>
				<br>
				<input
					class="row_2"
					type="submit"
					name="action"
					value="Return to Main Menu"
					tabindex=1
				>
				<hr>
				<strong>Select Report:</strong><br>
				<select name="select_report" tabindex=1>
					<option>&nbsp;</option> <!-- Blank at top of list -->
				<?php
					if (db("exists", "SELECT count(*) FROM $reports", $link)) {
					 	$reportlist = db("statement", "SELECT code FROM $reports ORDER BY code", $link);
						$rownum = 0;
						while ($item = db("nextrow", $reportlist)) {
							if ($item["code"] == 'default') continue;
							print "\t<option>{$item["code"]}</option>\n";
						}
					}
				?>
				</select>
				<br>
				<input
					class="submit"
					type="submit"
					name="action"
					value="Use Report"
					tabindex=1
				>
				&nbsp;&nbsp;&nbsp;
				<a href='<?php print "$self"; ?>?action=use+report&amp;select_report=<?php print urlencode("$name"); ?>#report_help'
					tabindex=1
				>Help</a>
				<br>
<?php
	// only last set status message is printed, so most critical tests should be done last
	// If no other message, use default
	if (!isset($status)) {
	 	$status = "\t<span class=status_msg>Editing . . .</span>\n";
	}
	print "<br><strong>$status</strong><BR>";
?>
				<span class=label><strong>Report: </strong></span>
					<span class="report_code"><strong><?php print htmlspecialchars("$name", ENT_QUOTES); ?></strong></span>
				<input type="hidden" name="report" value="<?php print htmlspecialchars("$name", ENT_QUOTES); ?>">
				<br>
				<span class=label>Description:</span><br>
				<textarea
					class=edit_controls
					rows=3
					cols=25
					name="description"
					tabindex=1
				><?php if (isset($FWLOG["description"])) print htmlspecialchars("{$FWLOG["description"]}", ENT_QUOTES); ?></textarea>
				<input type="hidden" name="page" value="spec">
				<div class="edit_controls">
				<table>
				<tr>
					<td>
						<input
							class="submit"
							type="submit"
							name="action"
							value="Save"
							tabindex=1
						>
					</td>
					<td>
						<input
							class="submit"
							type="submit"
							name="action"
							value="Delete"
							tabindex=1
						>
					</td>
				</tr>
				<tr>
					<td>
						<input
							class="submit"
							type="submit"
							name="action"
							value="Save as Default"
							tabindex=1
						>
					</td>
					<td>
						<input
							class="submit"
							type="submit"
							name="action"
							value="Import"
							tabindex=1
						>
					</td>
				</tr>
				<tr>
					<td>
						<input
							class="submit"
							type="submit"
							name="action"
							value="Create New"
							tabindex=1
						>
					</td>
					<td>
						<input
							class="submit"
							type="submit"
							name="action"
							value="Export"
							tabindex=1
						>
					</td>
				</tr>
				</table>
				</div>
				<hr>
			</td>          
		</tr>
		<tr>
			<td>
				<table>
					<caption ><strong>Report Options</strong>&nbsp;&nbsp;&nbsp;
						<a href='<?php print "$self"; ?>?action=use+report&amp;select_report=<?php print urlencode("$name"); ?>#options_help'
							tabindex=1
						>Help</a>
					</caption>
					<tr class=edit_opts>
						<td colspan="2">
						Select Data Source:<br>
							<input
								type="radio"
								name="data_source"
								value=""
								tabindex=1
								<?php if(!isset($FWLOG["data_source"])) print "checked\n"; ?>
							>
							&nbsp;Default
						</td>
					</tr>
					<tr class=edit_opts>
						<td colspan="2">
							<input
								type="radio"
								name="data_source"
								value="db"
								tabindex=1
								<?php if(isset($FWLOG["data_source"]) and strtolower("{$FWLOG["data_source"]}") == "db") print "checked\n"; ?>
							>
							&nbsp;Database&nbsp;&nbsp;Table: 
							<select name="data_tables[]" multiple size=3 tabindex=1>
								<option value="">Default</option>
								<?php
								$temp = array();
								if (isset($FWLOG["data_tables"]))
									$temp = array_flip($FWLOG["data_tables"]);
								if ("{$config["db"]}" <> "none")
									foreach(db("listtables","$data_d", $link) as $i) {
										print "<option";
										if (isset($temp["$i"])) print " selected";
										print ">".htmlspecialchars("{$i}", ENT_QUOTES)."</option>\n";
									}
								?>
							</select>
						</td>
					</tr>
					<tr class=edit_opts>
						<td colspan=2>
							<input
								type="radio"
								name="data_source"
								value="syslog"
								tabindex=1
								<?php if(isset($FWLOG["data_source"]) and strtolower("{$FWLOG["data_source"]}") == "syslog") print "checked\n"; ?>
							>
							&nbsp;Syslog&nbsp;Path:&nbsp;
							<?php print "{$config["syslog_dir"]}/"; ?>
							<br>
							File(s)&nbsp;
							<input
								type="text"
								size="20"
								name="syslog_file"
								value="<?php if (isset($FWLOG["syslog_file"])) print htmlspecialchars("{$FWLOG["syslog_file"]}", ENT_QUOTES); ?>"
								tabindex=1
							>
							<hr>
						</td>
					</tr>
					<tr class=edit_opts>
						<td colspan="2">Title (for heading of report)</td>
					</tr>
					<tr class=edit_opts>
						<td colspan="2">
							<input
								class=edit_opts_title
								type="text"
								size="28"
								name="report_title"
								value="<?php if (isset($FWLOG["report_title"])) print htmlspecialchars("{$FWLOG["report_title"]}", ENT_QUOTES); ?>"
								tabindex=1
							>
						</td>
					</tr>
					<tr class=edit_opts>
						<td>Rows per page</td>
						<td>
							<input
								class=edit_opts
								type="text"
								size=4
								name="page_length"
								value="<?php if (isset($FWLOG["page_length"])) print htmlspecialchars("{$FWLOG["page_length"]}", ENT_QUOTES); ?>"
								tabindex=1
						>
						</td>
					</tr>
					<tr class=edit_opts>
						<td>Page Refresh Rate</td>
						<td>
							<input
								class=edit_opts
								type="text"
								size=4
								name="refresh"
								value="<?php if (isset($FWLOG["refresh"])) print htmlspecialchars("{$FWLOG["refresh"]}", ENT_QUOTES); ?>"
								tabindex=1
						>
						</td>
					</tr>
					<tr class=edit_opts>
						<td>Update Hostname Cache</td>
						<td class=align_right>
							<input
								class=edit_opts_checkbox
								type="checkbox"
								<?php if (isset($FWLOG["upd_hosts"]) and $FWLOG["upd_hosts"]) print "checked"; print "\n";?>
								name="upd_hosts"
								value="on"
								tabindex=1
							>
						</td>
					</tr>
					<tr class=edit_opts>
						<td>Populate Hostname Cache</td>
						<td class=align_right>
							<input
								class=edit_opts_checkbox
								type="checkbox"
								<?php if (isset($FWLOG["populate_cache"]) and $FWLOG["populate_cache"]) print "checked"; print "\n" ?>
								name="populate_cache"
								value="on"
								tabindex=1
							>
						</td>
					</tr>
					<tr class=edit_opts>
						<td>Populate Cache Full</td>
						<td class=align_right>
							<input
								class=edit_opts_checkbox
								type="checkbox"
								<?php if (isset($FWLOG["populate_cache_full"]) and $FWLOG["populate_cache_full"]) print "checked"; print "\n" ?>
								name="populate_cache_full"
								value="on"
								tabindex=1
							>
						</td>
					</tr>
					<?php if ($config["allow_be_verbose"]) { ?>
					<tr class=edit_opts>
						<td>Be Verbose</td>
						<td class=align_right>
							<input
								class=edit_opts_checkbox 
								type="checkbox"
								<?php if (isset($FWLOG["be_verbose"]) and $FWLOG["be_verbose"]) print "checked"; print "\n";?>
								name="be_verbose"
								value="on"
								tabindex=1
						>
						</td>
					</tr>
					<?php } ?>
				</table>
			</td>
        </tr>
	</table>
	<hr>
	Update Hostname cache now.<br>
	This may take a LONG time.<br>
	<input
		class="submit"	
		type="submit"
		name="action"
		value="Update Cache"
		tabindex=1
	>
	</td> <!-- End of basic report info -->

	<td class="display_border edit_menus"> <!-- Begin Sorting menu -->
	<table>
		<caption>
			<strong>SUMMARIZE REPORT:</strong>
				<input
					type="checkbox"
					name="summarize"
					value="on" 
					<?php if (isset($FWLOG["summarize"]) and $FWLOG["summarize"]) print "checked\n"; ?>
					tabindex=10
				>
		</caption>
		<tr>
			<th scope=col class="align_left col_labels">Sort by:</th>
			<th scope=col>Order</th>
			<th scope=col title="Check to sort in Decending order">Desc</th>
		</tr>
		<?php
			$numrows = 11;
			for ($i=1; $i<=$numrows; $i++) {
				$a = $sortorder[$i - 1];
				$t = substr("$a",2);
				$o = $a; $o[0] = "o";
				$l = $longnames["$t"];
		?> 
		<tr>
			<td><?php print "{$longnames["$t"]}";?></td>
			<td>
				<input
					type="text"
					class="edit_num"
					size="3"
					maxlength="4"
					name="<?php print "$a"?>"
					value="<?php if (isset($FWLOG["$a"])) print htmlspecialchars("{$FWLOG["$a"]}", ENT_QUOTES)?>"
					tabindex=11
				>
			</td>
			<td>
				<input
					class="edit_checkbox"
					type="checkbox"
					<?php if (isset($FWLOG["$o"]) and "{$FWLOG["$o"]}") print "checked\n"; ?>
					name="<?php print "$o"?>"
					value="on"
					tabindex=11
				>
			</td>
		</tr>
		<?php } ?>
		<tr>
			<td class="edit_help_link">
				<a href="<?php print "$self"; ?>?action=use+report&amp;select_report=<?php print urlencode("$name"); ?>#sort_help"
					tabindex=19
				>Help</a>
			</td>
			<td colspan="2">
				<input
					class="submit"
					type="submit"
					name="sorting"
					value="More"
					tabindex=19
				>
			</td>
		</tr>
	</table>
	<?php  // Add hidden controls for any sort keys not showing on main form
		$offset = $numrows;
		print "\n";
		while (isset($sortorder[$offset]) and isset($FWLOG["$sortorder[$offset]"])) {
			$a = $sortorder[$offset];
			$t = substr("$a",2);
			$o = $a; $o[0] = "o";
			print "\t<input type='hidden' name='{$sortorder[$offset]}' value='{$FWLOG["$sortorder[$offset]"]}'>\n";
			print "\t<input type='hidden' name='{$o}' value='{$FWLOG["$o"]}'>\n";
			$offset++;
		}
		print "\n";
	?>
	</td> <!-- End Sorting menu -->

	<td class="display_border edit_menus"> <!-- Begin of Columns to include menu -->
	<table>
		<caption class="align_left"><strong>Select columns to include in report and order:</strong></caption>
	  	<?php
		$numrows = 11;
		$numcols = 2;
		for ($a = 0; $a <= ($numcols - 1);  $a++) {
			print "<col><col><col>";
		}
		print "\n";
		print "<tr>";
		for ($a = 0; $a <= ($numcols - 1);  $a++) {
    		print "<th scope=col>Link</th><th scope=col>Order</th><th class=\"align_left col_labels\" scope=col>Item</th>";
		}
		print "</tr>\n";
		for ($i = 0; $i <= ($numrows - 1);  $i++) {
			print "<tr>"; // row begin
			for ($j = 0; $j <= ($numcols - 1); $j++) {
				$colnum = $i + $j * $numrows ;
				if (!($a = $columnorder["$colnum"])) continue;
					$t = substr("$a",2);
					$l = $a; $l[0] = "l";
					$n = $longnames["$t"];
		?>
			<td>
			<?php	switch ("$l") {
						case "l_oob_time_sec":
						case "l_oob_time_usec":// These never get
						case "l_dst_host":	   // links.
						case "l_src_host":	 
						case "l_dst_service":
						case "l_src_service":
						case "l_local_time":
						case "l_oob_earliest":
						case "l_oob_latest":
						case "l_earliest":
						case "l_latest":
							break;
						default:
			?>
				<input
					class="edit_checkbox"
					type="checkbox"
					<?php if (isset($FWLOG["$l"]) and "{$FWLOG["$l"]}") print "checked\n"; ?>
					name="<?php print "$l"?>"
					value="on"
					tabindex=<?php $tindex = $j + 20; print "$tindex"; ?>
				>
			<?php 			break;
					}
			?>
			</td>
			<td>
				<input
					type="text"
					class="edit_num"
					size="3"
					maxlength="4"
					name="<?php print "$a"?>"
					value="<?php if (isset($FWLOG["$a"])) print "{$FWLOG["$a"]}"?>"
					tabindex=<?php $tindex = $j + 20; print "$tindex"; ?>
				>
			</td>
<?php if ("$a" == "c_extra") { ?>
	<td>Grp:&nbsp;
		<input
			type="checkbox"<?php if (isset($FWLOG["g_extra"])) print " checked\n"; print "\n"; ?>
			name="<?php print "g_extra"?>"
			value="on"
			tabindex=<?php print "$j\n"; ?>
		>
		&nbsp;
		<input
			type="text"
			size=25
			name="c_extra_value"
			value="<?php  if (isset($FWLOG["c_extra_value"])) print htmlspecialchars("{$FWLOG["c_extra_value"]}", ENT_QUOTES); ?>"
			tabindex=<?php print "$tindex\n"; ?>
		>
	</td>
<?php
		$have_extra = 1;
	} else { ?>
			<td><?php print "$n";?></td>
<?php
	}
			}
			print "</tr>\n"; //row end
		}
		?>
		<tr><td></td><td></td>
		<td colspan=2>
			<input
				class="submit"
				type="submit"
				name="selection"
				value="More"
				tabindex=20
			>
		</td>
		<td></td>
		<td>
			<a href='<?php print "$self"; ?>?action=use+report&amp;select_report=<?php print urlencode("$name"); ?>#columns_help'
				tabindex=29
			>Help</a>
		</td>
		</tr>
	</table>
	<?php  // Add hidden controls for any columns not showing on main form
		$offset = $numcols * $numrows;
		print "\n";
		while (isset($columnorder[$offset]) and isset($FWLOG["$columnorder[$offset]"])) {
			$a = $columnorder[$offset];
			$l = $a; $l[0] = "l";
			print "\t<input type='hidden' name='$a' value='{$FWLOG["$columnorder[$offset]"]}'>\n";
			if (isset($FWLOG["$l"])) print "\t<input type='hidden' name='{$l}' value='{$FWLOG["$l"]}'>\n";
			$offset++;
		} 
		if (!isset($have_extra) and isset($FWLOG["c_extra_value"]) and $config["allow_raw_sql"]) {
 			print "\t<input type='hidden' name='c_extra_value' value='".htmlspecialchars("{$FWLOG["c_extra_value"]}", ENT_QUOTES)."'>\n";
			if (isset($FWLOG["g_extra"]))
				print "\t<input type='hidden' name='g_extra' value='{$FWLOG["g_extra"]}'>\n";
		}
		print "\n";
	?>
	</td> <!-- End of Columns to include menu -->
</tr> <!-- Emd of first row -->

<tr> <!-- Begin of Second row -->
	<td class="display_border" rowspan="1" colspan="2"> <!-- Begin Criteria Menu -->
	<table class="tcp_opts">
		<caption class="align_left">
			<strong>Selection Criteria:</strong>
			&nbsp;&nbsp;&nbsp;&nbsp;
			<a href='<?php print "$self"; ?>?action=use+report&amp;select_report=<?php print urlencode("$name"); ?>#crit_help'
				tabindex=30
			>Help</a>
		</caption>
	<thead>
		<tr><th>Item</th><th>Search Value</th><th>Inv</th><th></th>
			<th>Item</th><th>Search Value</th><th>Inv</th></tr>
	</thead>
	<tbody>
		<tr><td>Min date:&nbsp;&nbsp;&nbsp;oob time
				<input
					type="checkbox"
					name="w_oob_min_date"
					<?php if (isset($FWLOG["w_oob_min_date"]) and $FWLOG["w_oob_min_date"]) print "checked\n"; ?>
					value="on"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_min_date"
					value="<?php if (isset($FWLOG["w_min_date"])) print htmlspecialchars("{$FWLOG["w_min_date"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td></td>
			<td></td>
			<td>Max date:&nbsp;&nbsp;&nbsp;oob time
				<input
					type="checkbox"
					name="w_oob_max_date"
					<?php if (isset($FWLOG["w_oob_max_date"]) and $FWLOG["w_oob_max_date"]) print "checked\n"; ?>
					value="on"
					tabindex=31
				>
			</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_max_date"
					value="<?php if (isset($FWLOG["w_max_date"])) print htmlspecialchars("{$FWLOG["w_max_date"]}", ENT_QUOTES); ?>"
					tabindex=31
				>
			</td>
			<td></td>
		</tr>
		<tr><td><?php print "{$longnames['local_hostname']}"?> (regexp):</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14 name="w_local_hostname"
					value="<?php if (isset($FWLOG["w_local_hostname"])) print htmlspecialchars("{$FWLOG["w_local_hostname"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_local_hostname"]) and $FWLOG["i_local_hostname"]) print "checked\n"; ?>
					name="i_local_hostname"
					value="on"
					tabindex=30
				>
			</td>
			<td></td>
			<td class=tcp_opts colspan="3" rowspan="3">
				<table>
				<tr><td colspan="3">TCP Options to include:</td></tr>
				<tr>  
				<td>
					<input
						class="tcp_opts_input"
						type="checkbox"
						<?php if (isset($FWLOG["w_tcp_syn"]) and $FWLOG["w_tcp_syn"]) print "checked\n"; ?>
						name="w_tcp_syn"
						value="on"
						tabindex=31
					>
					<span class="tcp_opts_label">tcp_syn</span>
				</td>
				<td>
					<input
						class="tcp_opts_input"
						type="checkbox"
						<?php if (isset($FWLOG["w_tcp_fin"]) and $FWLOG["w_tcp_fin"]) print "checked\n"; ?>
						name="w_tcp_fin"
						value="on"
						tabindex=31
					>
					<span class="tcp_opts_label">tcp_fin</span>
				</td>
				<td>
					<input
						class="tcp_opts_input"
						type="checkbox"
						<?php if (isset($FWLOG["w_tcp_rst"]) and $FWLOG["w_tcp_rst"]) print "checked\n"; ?>
						name="w_tcp_rst"
						value="on"
						tabindex=31
					>
					<span class="tcp_opts_label">tcp_rst</span>
				</td>
				</tr>
				<tr>
				<td>
					<input
						class="tcp_opts_input"
						type="checkbox"
						<?php if (isset($FWLOG["w_tcp_ack"]) and $FWLOG["w_tcp_ack"]) print "checked\n"; ?>
						name="w_tcp_ack"
						value="on"
						tabindex=31
					>
					<span class="tcp_opts_label">tcp_ack</span>
				</td>
				<td>
					<input
						class="tcp_opts_input"
						type="checkbox"
						<?php if (isset($FWLOG["w_tcp_urg"]) and $FWLOG["w_tcp_urg"]) print "checked\n"; ?>
						name="w_tcp_urg"
						value="on"
						tabindex=31
					>
					<span class="tcp_opts_label">tcp_urg</span>
				</td>
				<td>
					<input
						class="tcp_opts_input"
						type="checkbox"
						<?php if (isset($FWLOG["w_tcp_psh"]) and $FWLOG["w_tcp_psh"]) print "checked\n"; ?>
						name="w_tcp_psh"
						value="on"
						tabindex=31
					>
					<span class="tcp_opts_label">tcp_psh</span>
				</td>
				</tr>
				<tr>
				<td colspan="3">
					TCP Options exact match:
					<input
						class="tcp_opts_input"
						type="checkbox"
						<?php if (isset($FWLOG["w_tcp_options"]) and $FWLOG["w_tcp_options"]) print "checked\n"; ?>
						name="w_tcp_options"
						value="on"
						tabindex=31
					>
				</td>
				</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td><?php print "{$longnames['oob_prefix']}"?> (regexp):</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_oob_prefix"
					value="<?php if (isset($FWLOG["w_oob_prefix"])) print htmlspecialchars("{$FWLOG["w_oob_prefix"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_oob_prefix"]) and $FWLOG["i_oob_prefix"]) print "checked\n"; ?>
					name="i_oob_prefix"
					value="on"
					tabindex=30
				>
			</td>
			<td></td>
		</tr>
		<tr>
			<td><?php print "{$longnames['ip_protocol']}"?> (name or number):</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_ip_protocol"
					value="<?php if (isset($FWLOG["w_ip_protocol"])) print htmlspecialchars("{$FWLOG["w_ip_protocol"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_ip_protocol"]) and $FWLOG["i_ip_protocol"]) print "checked\n"; ?>
					name="i_ip_protocol" value="on"
					tabindex=30
				>
			</td>
			<td></td>
		</tr>
		<tr><td><?php print "{$longnames['tcp_sport']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_tcp_sport"
					value="<?php if (isset($FWLOG["w_tcp_sport"])) print htmlspecialchars("{$FWLOG["w_tcp_sport"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_tcp_sport"]) and $FWLOG["i_tcp_sport"]) print "checked\n"; ?>
					name="i_tcp_sport"
					value="on"
					tabindex=30
				>
			</td>
			<td></td>
			<td><?php print "{$longnames['tcp_dport']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_tcp_dport"
					value="<?php if (isset($FWLOG["w_tcp_dport"])) print htmlspecialchars("{$FWLOG["w_tcp_dport"]}", ENT_QUOTES); ?>"
					tabindex=31
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_tcp_dport"]) and $FWLOG["i_tcp_dport"]) print "checked\n"; ?>
					name="i_tcp_dport"
					value="on"
					tabindex=31
				>
			</td>
		</tr>
		<tr>
			<td><?php print "{$longnames['udp_sport']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_udp_sport"
					value="<?php if (isset($FWLOG["w_udp_sport"])) print htmlspecialchars("{$FWLOG["w_udp_sport"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_udp_sport"]) and $FWLOG["i_udp_sport"]) print "checked\n"; ?>
					name="i_udp_sport"
					value="on"
					tabindex=30
				>
			</td>
			<td></td>
			<td><?php print "{$longnames['udp_dport']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_udp_dport"
					value="<?php if (isset($FWLOG["w_udp_dport"])) print htmlspecialchars("{$FWLOG["w_udp_dport"]}", ENT_QUOTES); ?>"
					tabindex=31
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_udp_dport"]) and $FWLOG["i_udp_dport"]) print "checked\n"; ?>
					name="i_udp_dport"
					value="on"
					tabindex=31
				>
			</td>
		</tr>
		<tr>
			<td><?php print "{$longnames['icmp_type']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_icmp_type"
					value="<?php if (isset($FWLOG["w_icmp_type"])) print htmlspecialchars("{$FWLOG["w_icmp_type"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_icmp_type"]) and $FWLOG["i_icmp_type"]) print "checked\n"; ?>
					name="i_icmp_type"
					value="on"
					tabindex=30
				>
			</td>
			<td></td>
		    <td><?php print "{$longnames['icmp_code']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_icmp_code"
					value="<?php if (isset($FWLOG["w_icmp_code"])) print htmlspecialchars("{$FWLOG["w_icmp_code"]}", ENT_QUOTES); ?>"
					tabindex=31
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_icmp_code"]) and $FWLOG["i_icmp_code"]) print "checked\n"; ?>
					name="i_icmp_code"
					value="on"
					tabindex=31
				>
			</td>
		</tr>
		<tr>
			<td><?php print "{$longnames['icmpv6_type']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_icmpv6_type"
					value="<?php if (isset($FWLOG["w_icmpv6_type"])) print htmlspecialchars("{$FWLOG["w_icmpv6_type"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_icmpv6_type"]) and $FWLOG["i_icmpv6_type"]) print "checked\n"; ?>
					name="i_icmpv6_type"
					value="on"
					tabindex=30
				>
			</td>
			<td></td>
		    <td><?php print "{$longnames['icmpv6_code']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_icmpv6_code"
					value="<?php if (isset($FWLOG["w_icmpv6_code"])) print htmlspecialchars("{$FWLOG["w_icmpv6_code"]}", ENT_QUOTES); ?>"
					tabindex=31
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_icmpv6_code"]) and $FWLOG["i_icmpv6_code"]) print "checked\n"; ?>
					name="i_icmpv6_code"
					value="on"
					tabindex=31
				>
			</td>
		</tr>
		<tr>
			<td><?php print "{$longnames['ip_saddr']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_ip_saddr"
					value="<?php if (isset($FWLOG["w_ip_saddr"])) print htmlspecialchars("{$FWLOG["w_ip_saddr"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_ip_saddr"]) and $FWLOG["i_ip_saddr"]) print "checked\n"; ?>
					name="i_ip_saddr"
					value="on"
					tabindex=30
				>
			</td>
			<td></td>
			<td><?php print "{$longnames['ip_daddr']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_ip_daddr"
					value="<?php if (isset($FWLOG["w_ip_daddr"])) print htmlspecialchars("{$FWLOG["w_ip_daddr"]}", ENT_QUOTES); ?>"
					tabindex=31
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_ip_daddr"]) and $FWLOG["i_ip_daddr"]) print "checked\n"; ?>
					name="i_ip_daddr"
					value="on"
					tabindex=31
				>
			</td>
		</tr>
		<tr>
			<td><?php print "{$longnames['oob_in']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_oob_in"
					value="<?php if (isset($FWLOG["w_oob_in"])) print htmlspecialchars("{$FWLOG["w_oob_in"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_oob_in"]) and $FWLOG["i_oob_in"]) print "checked\n"; ?>
					name="i_oob_in"
					value="on"
					tabindex=30
				>
			</td>
			<td></td>
			<td><?php print "{$longnames['oob_out']}"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_oob_out"
					value="<?php if (isset($FWLOG["w_oob_out"])) print htmlspecialchars("{$FWLOG["w_oob_out"]}", ENT_QUOTES); ?>"
					tabindex=31
				>
			</td>
			<td>
				<input
					type="checkbox"
					class=edit_checkbox
					<?php if (isset($FWLOG["i_oob_out"]) and $FWLOG["i_oob_out"]) print "checked\n"; ?>
					name="i_oob_out"
					value="on"
					tabindex=31
				>
			</td>
		</tr>
		<tr>
			<td><?php print "Minimum Count"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_min_count"
					value="<?php if (isset($FWLOG["w_min_count"])) print htmlspecialchars("{$FWLOG["w_min_count"]}", ENT_QUOTES); ?>"
					tabindex=30
				>
			</td>
			<td></td>
			<td></td>
			<td><?php print "Maximum Count"?>:</td>
			<td>
				<input
					type="text"
					class=edit_text
					size=14
					name="w_max_count"
					value="<?php if (isset($FWLOG["w_max_count"])) print htmlspecialchars("{$FWLOG["w_max_count"]}", ENT_QUOTES); ?>"
					tabindex=31
				>
			</td>
			<td></td>
		</tr>
		<tr>
		<td colspan=7>
			<br>
			<em>There may be additional criteria specified.  Press More to review.</em>&nbsp;
			<input
				class="submit"
				type="submit"
				name="criteria"
				value="More"
				tabindex=30
			>
		</td>
		</tr>
	</tbody>
	</table>
	<?php  // Add hidden controls for any criteria not showing on main form
		print "\n";
		$f_noinv = array();
		$f_noinv[] = 'min_latest';
		$f_noinv[] = 'max_earliest';
		$f_noinv[] = 'oob_min_latest';
		$f_noinv[] = 'oob_max_earliest';
		$f_noinv[] = 'ip_df';
		$f_noinv[] = 'ip_mf';
		$f_noinv[] = 'is_anonymous_proxy_s';
		$f_noinv[] = 'is_satellite_provider_s';
		$f_noinv[] = 'is_in_european_union_s';
		$f_noinv[] = 'is_anonymous_proxy_d';
		$f_noinv[] = 'is_satellite_provider_d';
		$f_noinv[] = 'is_in_european_union_d';

		$f_inv = array();
		$f_inv[] = 'oob_family';
		$f_inv[] = 'ip_tos';
		$f_inv[] = 'ip_ttl';
		$f_inv[] = 'ip_ihl';
		$f_inv[] = 'ip_totlen';
		$f_inv[] = 'ip_id';
		$f_inv[] = 'ip_csum';
		$f_inv[] = 'ip6_flowlabel';
		$f_inv[] = 'ip6_payloadlen';
		$f_inv[] = 'ip_fragoff';
		$f_inv[] = 'tcp_seq';
		$f_inv[] = 'tcp_ackseq';
		$f_inv[] = 'tcp_window';
		$f_inv[] = 'tcp_urgp';
		$f_inv[] = 'tcp_off';
		$f_inv[] = 'tcp_csum';
		$f_inv[] = 'icmp_echoid';
		$f_inv[] = 'icmp_echoseq';
		$f_inv[] = 'icmp_gateway';
		$f_inv[] = 'icmp_fragmtu';
		$f_inv[] = 'icmpv6_echoid';
		$f_inv[] = 'icmpv6_echoseq';
		$f_inv[] = 'udp_len';
		$f_inv[] = 'udp_csum';
		$f_inv[] = 'raw_type';
		$f_inv[] = 'oob_protocol';
		$f_inv[] = 'mac_saddr_str';
		$f_inv[] = 'mac_daddr_str';
		$f_inv[] = 'raw_mac';
		$f_inv[] = 'oob_hook';
		$f_inv[] = 'oob_mark';
		$f_inv[] = 'ahesp_spi';
		$f_inv[] = 'oob_time_usec';
		$f_inv[] = 'continent_code_s';
		$f_inv[] = 'continent_name_s';
		$f_inv[] = 'country_iso_code_s';
		$f_inv[] = 'country_name_s';
		$f_inv[] = 'subdivision_1_iso_code_s';
		$f_inv[] = 'subdivision_1_name_s';
		$f_inv[] = 'subdivision_2_iso_code_s';
		$f_inv[] = 'subdivision_2_name_s';
		$f_inv[] = 'city_name_s';
		$f_inv[] = 'metro_code_s';
		$f_inv[] = 'time_zone_s';
		$f_inv[] = 'accuracy_radius_s';
		$f_inv[] = 'registered_country_geoname_id_s';
		$f_inv[] = 'represented_country_geoname_id_s';
		$f_inv[] = 'postal_code_s';
		$f_inv[] = 'latitude_s';
		$f_inv[] = 'longitude_s';
		$f_inv[] = 'autonomous_system_number_s';
		$f_inv[] = 'autonomous_system_organization_s';
		$f_inv[] = 'continent_code_d';
		$f_inv[] = 'continent_name_d';
		$f_inv[] = 'country_iso_code_d';
		$f_inv[] = 'country_name_d';
		$f_inv[] = 'subdivision_1_iso_code_d';
		$f_inv[] = 'subdivision_1_name_d';
		$f_inv[] = 'subdivision_2_iso_code_d';
		$f_inv[] = 'subdivision_2_name_d';
		$f_inv[] = 'city_name_d';
		$f_inv[] = 'metro_code_d';
		$f_inv[] = 'time_zone_d';
		$f_inv[] = 'accuracy_radius_d';
		$f_inv[] = 'registered_country_geoname_id_d';
		$f_inv[] = 'represented_country_geoname_id_d';
		$f_inv[] = 'postal_code_d';
		$f_inv[] = 'autonomous_system_number_d';
		$f_inv[] = 'autonomous_system_organization_d';
		$f_inv[] = 'latitude_d';
		$f_inv[] = 'longitude_d';
		$f_inv[] = 'pwsniff_user';
		$f_inv[] = 'pwsniff_pass';

		foreach ($f_noinv as $f)
			if (isset($FWLOG["w_$f"])) print "\t<input type='hidden' name='w_$f' value='".htmlspecialchars("{$FWLOG["w_$f"]}", ENT_QUOTES)."'>\n";

		foreach ($f_inv as $f) {
			if (isset($FWLOG["w_$f"])) print "\t<input type='hidden' name='w_$f' value='".htmlspecialchars("{$FWLOG["w_$f"]}", ENT_QUOTES)."'>\n";
			if (isset($FWLOG["i_$f"])) print "\t<input type='hidden' name='i_$f' value='".htmlspecialchars("{$FWLOG["i_$f"]}", ENT_QUOTES)."'>\n";
		}

		if (isset($FWLOG['w_extra']) and $config["allow_raw_sql"]) print "\t<input type='hidden' name='w_extra' value='".htmlspecialchars("{$FWLOG['w_extra']}", ENT_QUOTES)."'>\n";
		if (isset($FWLOG['h_extra']) and $config["allow_raw_sql"]) print "\t<input type='hidden' name='h_extra' value='".htmlspecialchars("{$FWLOG['h_extra']}", ENT_QUOTES)."'>\n";
		print "\n";
	?>
	</td> <!-- End of Criteria Menu -->
</tr> <!-- End of Second row -->
</table> <!-- End of Main Table -->

</form> <!-- End of Form -->
</td>
</tr>
<?php
	db("close", $link);
	$doc_page = "editor";
	include "include/edit_doc.php";
?>
</table>
</div>

</body>
</html>

<!-- vim:set ts=4: -->
