<?php
/*
$Id: save_report.php 727 2023-11-16 20:40:20Z bhockney $
(C) 2003-2023 by Bob Hockney <zeus@ix.netcom.com>

confirm save of report definitions

This code is distributed under the terms of GNU GPL
*/
?>

<?php
$link = db("open", "$database");

if (strtolower($FWLOG["action"]) == "commit") {
	$ORIG_FWLOG = $FWLOG;
	if (db("exists", "SELECT count(*) FROM $reports", $link)) {
		$name = trim($FWLOG["save_report"]);
		if (preg_match("/^[a-zA-Z0-9_]+\$/", "$name") or $name == "") {
			$report = $name;
			//if committing, UPDATE if report code already exists, otherwise INSERT
			$FWLOG = definition_do_not_save($FWLOG);
			unset ($FWLOG["report"]);
			$definition = db("escape", serialize($FWLOG), $link);
			$rownum = 0;
			if (db("nextrow", db("statement", "SELECT code FROM $reports WHERE code ='".db("escape", "$report", $link)."'", $link))) {
				if (db("exists", "SELECT last_saved FROM $reports", $link)) {
					$l_saved = ", last_saved = $time ";
				} else {
					$l_saved = "";
				}
				if (isset($FWLOG["description"])) {
					$description = db("escape", "{$FWLOG["description"]}", $link);
				} else {
					$description = "";
				}
				if (!db("statement", "UPDATE $reports 
					SET description = '$description',
						definition  = '$definition'
						$l_saved
					WHERE code='".db("escape", "$report", $link)."'", $link)
					)
					$status = "\tERROR: REPORT NOT SAVED\n";
			} else {
				if (db("statement", "INSERT INTO $reports
					(code, description, definition) 
					VALUES ('".db("escape", "$report", $link)."','"
					.db("escape", "{$FWLOG["description"]}", $link)."', '$definition')", $link)) {
					if (db("exists", "SELECT last_saved, last_accessed FROM $reports", $link)) {
						db("statement", "UPDATE $reports 
							SET last_saved = $time,
								last_accessed = $time
							WHERE code='".db("escape", "$report", $link)."'", $link);
					}
				} else {
					$status = "\tERROR: REPORT NOT SAVED\n";
				}
			}
			$FWLOG = $ORIG_FWLOG;
			$FWLOG["report"] = $report;
			unset ($name); 
			$status = "\tREPORT {$FWLOG["report"]} SAVED\n";
			db("close", $link);
			include "include/edit_report.php";
			exit();
		}
	} else {
		$status = "<span class=\"err_msg\">CANNOT OPEN DATATBASE<br>REPORT NOT SAVED</span>";
		$FWLOG["report"] = $FWLOG["save_report"];
	} // End of "save"
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>Webfwlog - Save Report</title>
  <LINK REL=StyleSheet HREF="style.css" TYPE="text/css" MEDIA=screen>
</head>

<body>
	<h1 class="align_center"><?php print "{$config["title"]}"; ?></h1>
	<?php if ($config["debug"]) include "include/debug.php"; ?>

<form action="<?php print "$self"; ?>" method="POST">

<?php
	if (isset($FWLOG["save_report"])) {
		$code = $FWLOG["save_report"];
	} else {
		$code = $FWLOG["report"];
	}
	$rownum = 0;
	if (db("exists", "SELECT count(*) FROM $reports", $link) and
		$result = db("statement", "SELECT code FROM $reports WHERE code='".db("escape", "$code", $link)."'", $link) and
		db("nextrow", $result))
			$savecode = $code;

	db("close", $link);

	foreach ($FWLOG as $a => $b) {
			if (!($a == "page" or $a == "data_tables"))
			print "<input type='hidden' name=\"".htmlspecialchars("$a", ENT_QUOTES)
				."\" value=\"".htmlspecialchars("$b", ENT_QUOTES)."\">\n";
	}
?>
<input type='hidden' name='page' value='save'>

<div class="align_center">
<table class="align_table">
  <caption>
     SAVE REPORT DEFINITION<br><br>
	 <?php if (isset($status)) print "$status"; ?>
  </caption>
    <tr>
    	<td class="status_msg display_border align_left" colspan="2">
			<strong>
			<?php if (isset($savecode)) {
				 print "\t<span class='err_msg'>$code exists:<br>Committing will overwrite existing definition!</span>\n";
			} else {
				print "\t<span class='normal_msg'>PLEASE ENTER A REPORT CODE<br>\n" .
					  "\tMust Contain only Alphanumeric + '_' : [a-zA-Z0-9_]+</span>\n";
			}
			?>
			</strong>
		</td>	
	</tr>
	<tr>
		<td class="save_label display_border align_left">Description:</td>
		<td class="align_left display_border"><?php if (isset($FWLOG["description"])) print htmlspecialchars("{$FWLOG["description"]}", ENT_QUOTES); ?></td>      
    </tr>
    <tr>
      <td class="align_left display_border">Report Code:</td>
      <td class="align_left display_border"><input type="text" name="save_report" size="20" value="<?php print htmlspecialchars("$code", ENT_QUOTES); ?>"></td>
    </tr>
    <tr>
    	<td class="align_left display_border" colspan="2">
			<input class="submit" type="submit" name="action" value="Refresh">&nbsp;&nbsp;
			<input class="submit" type="submit" name="action" value="Commit">&nbsp;&nbsp;
			<input class="submit" type="submit" name="save" value="Cancel">
		</td>
	</tr>
</table>
</div>

</form>

</body>
</html>

<!-- vim:set ts=4: -->
