<?php
/*
$Id: selection.php 727 2023-11-16 20:40:20Z bhockney $
(C) 2003-2023 by Bob Hockney <zeus@ix.netcom.com>

column selection form

This code is distributed under the terms of GNU GPL
*/
?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>Webfwlog - Edit Report <?php print "{$FWLOG["report"]}" ?> - Selection</title>
  <LINK REL=StyleSheet HREF="style.css" TYPE="text/css" MEDIA=screen>
</head>

<body>
<?php if ($config["debug"]) include "include/debug.php"; ?>
<h1 class="align_center"><?php print "{$config["title"]}"; ?></h1>

<div class="align_center">
<table class="align_table">
<tr>
<td>
<form action="<?php print "$self"; ?>" method="POST">
<?php
	foreach ($FWLOG as $a => $b) {
		if (!(substr($a,0,2) == "c_") and !(substr($a,0,2) == "l_") and !(substr($a,0,2) == "g_")
		  and !($a == "data_tables")
		  and !($a == "selection")
		  and !($a == "page")) {
			print "<input type='hidden' name='".htmlspecialchars("$a", ENT_QUOTES).
				"' value='".htmlspecialchars("$b", ENT_QUOTES)."'>\n";
		}
	}
?>
<input type="hidden" name="page" value="selection">

<table class="align_left display_border">
	<tr>
	<td>  
	<!-- Select to include menu -->
	<table>
		<caption class="align_left"><strong>Select report columns and order</strong></caption>
	<?php
		$numrows = 35;
		$numcols = 3;
		print "<tr>\n";
		for ($a = 0; $a <= ($numcols - 1);  $a++) {
	    	print "\t<th scope=col>Link</th>\n\t<th scope=col>Order</th>\n\t<th scope=col>Item</th>\n";
		}
		print "</tr>\n";
		for ($i = 0; $i <= ($numrows - 1);  $i++) {
			print "<tr>";
			for ($j = 1; $j <= $numcols; $j++) {
				$colnum = $i + ($j - 1) * $numrows;
				if (!isset($columnorder["$colnum"])) { 
					print "\t<td></td><td></td><td></td>\n";
				} else {
					$a = $columnorder["$colnum"];
					$t = substr("$a",2);
					$l = $a; $l[0] = "l";
					$n = $longnames["$t"];
?> 
	<td>
<?php			switch ("$l") {
				case "l_oob_time_sec":
				case "l_oob_time_usec":// These never get
				case "l_dst_host":	   // links.
				case "l_src_host":	 
				case "l_dst_service":
				case "l_src_service":
				case "l_local_time":
				case "l_oob_earliest":
				case "l_oob_latest":
				case "l_earliest":
				case "l_latest":
					break;
				default:
?>
		<input
			class="edit_checkbox"
			type="checkbox"
			<?php if (isset($FWLOG["$l"])) print "checked"; ?> 
			name="<?php print "$l"?>"
			value="on"
			tabindex=<?php print "$j\n"; ?>
		>
<?php   		        break;
				}
?>
	</td>
	<td>
		<input
			class="edit_num"
			type="text"
			size="3"
			maxlength="4"
			name="<?php print "$a"?>"
			value="<?php if (isset($FWLOG["$a"])) print "{$FWLOG["$a"]}"?>"
			tabindex=<?php print "$j\n"; ?>
		>
	</td>
<?php if ("$a" == "c_extra") { ?>
	<td>Grp:
		<input
			class="edit_checkbox"
			type="checkbox"
			<?php if (isset($FWLOG["g_extra"])) print "checked"; ?>  
			name="<?php print "g_extra"?>"
			value="on"
			tabindex=<?php print "$j\n"; ?>
		>
		<input
			class="edit_text"
			type="text"
			size=20
			name="c_extra_value"
			value="<?php if (isset($FWLOG["c_extra_value"])) print htmlspecialchars("{$FWLOG["c_extra_value"]}", ENT_QUOTES); ?>"
			tabindex=<?php print "$j\n"; ?>
		>
	</td>
<?php } else { ?>
	<td><?php print "$n";?></td>
<?php
	}
			}
			}
			print "</tr>\n";
		}
?>
	</table>
	<!-- End of Select to include menu -->
	</td>
</tr>
<tr>
	<td class="bottom_submit">
	<input class="submit" type="submit" name="action" value="Refresh">&nbsp;
	<input class="submit" type="reset" value="Reset">&nbsp;
	<input class="submit" type="submit" name="action" value="Accept">&nbsp;
	</td>
</tr>
</table>
</form>
</td>
</tr>
<?php
	$doc_page = "selection";
	include "include/edit_doc.php";
?>
</table>
</div>

</body>
</html>

<!-- vim:set ts=4: -->
