<?php
/*
$Id: static.php 727 2023-11-16 20:40:20Z bhockney $
(C) 2003-2023 by Bob Hockney <zeus@ix.netcom.com>

static data for webfwlog

This code is distributed under the terms of GNU GPL
*/
?>
<?php

// This file contains static data

// Long Names are used as descriptions on the report specification form
// Short Names are used as column headings on reports
// Edit at your own risk!

// Long Names for variables
$longnames = array(
	'sname'				=> 'Source Name',
	'id'				=> 'Record Num',
	'count'				=> 'Count',
	'oob_time_sec'		=> 'Time',
	'oob_time_usec'		=> 'Time &micro;sec',
	'oob_in'			=> 'Input Interface',
	'oob_out'			=> 'Output Interface',
	'earliest'			=> 'Earliest time',
	'latest'			=> 'Latest time',
	'oob_earliest'		=> 'Earliest OOB time',
	'oob_latest'		=> 'Latest OOB time',
	'oob_prefix'		=> 'Log Label',
	'oob_mark'			=> 'Firewall Mark',
	'oob_family'		=> 'IP Family',
	'ip_protocol'		=> 'IP Protocol',
	'ip_saddr'			=> 'Source IP',
	'src_host'			=> 'Source Host',
	'ip_daddr'			=> 'Destination IP',
	'dst_host'			=> 'Destination Host',
	'ip_tos'			=> 'IP TOS / IPv6 TC',
	'ip_ttl'			=> 'IP TTL / IPv6 Hoplimit',
	'ip_totlen'			=> 'IP Total Length',
	'ip_ihl'			=> 'IP Header Length',
	'ip_csum'			=> 'IP Checksum',
	'ip_id'				=> 'IP ID',
	'ip_fragoff'		=> 'Fragmentation Offset',
	'ip6_priority'		=> 'IPv6 Traffic Class',
	'ip6_hoplimit'		=> 'IPv6 Hoplimit',
	'ip6_flowlabel'		=> 'IPv6 Flowlabel',
	'ip6_payloadlen'	=> 'IPv6 Payload Length',
	'ip6_fragid'		=> 'IPv6 Fragmentation ID',
	'ip6_fragoff'		=> 'IPv6 Fragmentation Offset',
	'sport'				=> 'Source Port',
	'src_service'		=> 'Source Service',
	'dport'				=> 'Destination Port',
	'dst_service'		=> 'Destination Service',
	'tcp_sport'			=> 'TCP Source Port',
	'tcp_dport'			=> 'TCP Destination Port',
	'tcp_seq'			=> 'TCP Sequence Number',
	'tcp_ackseq'		=> 'TCP ACK Sequence Number',
	'tcp_window'		=> 'TCP Window',
	'tcp_off'			=> 'TCP Data Offset',
	'tcp_csum'			=> 'TCP Checksum',
	'tcp_options'		=> 'TCP Options',
	'tcp_urg'			=> 'tcp_urg',
	'tcp_urgp'			=> 'TCP Urgent Pointer',
	'tcp_ack'			=> 'tcp_ack',
	'tcp_psh'			=> 'tcp_psh',
	'tcp_rst'			=> 'tcp_rst',
	'tcp_syn'			=> 'tcp_syn',
	'tcp_fin'			=> 'tcp_fin',
	'udp_sport'			=> 'UDP Source Port',
	'udp_dport'			=> 'UDP Destination Port',
	'udp_len'			=> 'UDP Length',
	'udp_csum'			=> 'UDP Checksum',
	'icmptype'			=> 'ICMP Type',
	'icmpcode'			=> 'ICMP Code',
	'icmpechoid'		=> 'ICMP Echo ID',
	'icmpechoseq'		=> 'ICMP Echo Sequence Number',
	'icmpcsum'			=> 'ICMP Checksum',
	'icmp_type'			=> 'ICMPv4 Type',
	'icmp_code'			=> 'ICMPv4 Code',
	'icmp_echoid'		=> 'ICMPv4 Echo ID',
	'icmp_echoseq'		=> 'ICMPv4 Echo Sequence Number',
	'icmp_gateway'		=> 'ICMPv4 Redirect Gateway',
	'icmp_fragmtu'		=> 'ICMPv4 Next Hop MTU',
	'icmp_csum'			=> 'ICMPv4 Checksum',
	'icmpv6_type'		=> 'ICMPv6 Type',
	'icmpv6_code'		=> 'ICMPv6 Code',
	'icmpv6_echoid'		=> 'ICMPv6 Echo ID',
	'icmpv6_echoseq'	=> 'ICMPv6 Echo Sequence Number',
	'icmpv6_csum'		=> 'ICMPv6 Checksum',
	'raw_type'			=> 'ARP HW Type',
	'raw_mac'			=> 'MAC String',
	'oob_protocol'		=> 'Ethernet Protocol',
	'mac_saddr_str'		=> 'Source MAC',
	'mac_daddr_str'		=> 'Destination MAC',
	'oob_hook'			=> 'Netfilter Hook',
	'local_time'		=> 'Local Time',
	'local_hostname'	=> 'Local Host',
	'continent_code_s'	=> 'Source Continent Code',
	'continent_name_s'	=> 'Source Continent',
	'country_iso_code_s'	=> 'Source Country ISO',
	'country_name_s'		=> 'Source Country',
	'subdivision_1_iso_code_s'	=> 'Source Subdivision 1 Code',
	'subdivision_1_name_s'		=> 'Source Subdivision 1 Name',
	'subdivision_2_iso_code_s'	=> 'Source Subdivision 2 Code',
	'subdivision_2_name_s'		=> 'Source subdivision 2 Name',
	'city_name_s'		=> 'Source City Name',
	'metro_code_s'		=> 'Source Metro Code',
	'time_zone_s'		=> 'Source Time Zone',
	'accuracy_radius_s'	=> 'Source Location Accuracy',
	'registered_country_geoname_id_s'	=> 'Source Registered Country',
	'represented_country_geoname_id_s'	=> 'Source Represented Country',
	'is_anonymous_proxy_s'		=> 'Source Is Anonymous Proxy?',
	'is_satellite_provider_s'	=> 'Source Is Satellite Provider?',
	'postal_code_s'		=> 'Source Postal Code',
	'latitude_s'		=> 'Source Latitude',
	'longitude_s'		=> 'Source Longitude',
	'is_in_european_union_s'	=> 'Source In European Union?',
	'autonomous_system_number_s'	=> 'Source Autonomous System Number',
	'autonomous_system_organization_s'	=> 'Source Autonomous System Organization',
	'continent_code_d'	=> 'Destination Continent Code',
	'continent_name_d'	=> 'Destination Continent',
	'country_iso_code_d'	=> 'Destination Country ISO',
	'country_name_d'		=> 'Destination Country',
	'subdivision_1_iso_code_d'	=> 'Destination Subdivision 1 Code',
	'subdivision_1_name_d'		=> 'Destination Subdivision 1 Name',
	'subdivision_2_iso_code_d'	=> 'Destination Subdivision 2 Code',
	'subdivision_2_name_d'		=> 'Destination Subdivision 2 Name',
	'city_name_d'		=> 'Destination City Name',
	'metro_code_d'		=> 'Destination Metro Code',
	'time_zone_d'		=> 'Destination Time Zone',
	'accuracy_radius_d'	=> 'Destination Location Accuracy',
	'registered_country_geoname_id_d'	=> 'Destination Registered Country',
	'represented_country_geoname_id_d'	=> 'Destination Represented Country',
	'is_anonymous_proxy_d'		=> 'Destination Is Anonymous Proxy?',
	'is_satellite_provider_d'	=> 'Destination Is Satellite Provider?',
	'postal_code_d'		=> 'Destination Postal Code',
	'latitude_d'		=> 'Destination Latitude',
	'longitude_d'		=> 'Destination Longitude',
	'is_in_european_union_d'	=> 'Destination In European Union?',
	'autonomous_system_number_d'	=> 'Destination Autonomous System Number',
	'autonomous_system_organization_d'	=> 'Destination Autonomous System Organization',
	'pwsniff_user'		=> 'pwsniff user',
	'pwsniff_pass'		=> 'pwsniff pass',
	'ahesp_spi'			=> 'AH/ESP protocol SPI',
	'extra'				=> 'Arbitrary column'
);

// Short Names for variables
// Must be unique
$shortnames = array(
	'local_hostname'	=> 'Local Host',
	'oob_in'			=> 'In If',
	'oob_out'			=> 'Out If',
	'count'				=> 'Count',
	'sname'				=> 'Source',
	'id'				=> 'Packet',
	'oob_time_sec'		=> 'Time',
	'oob_time_usec'		=> 'Time &micro;sec',
	'earliest'			=> 'Earliest',
	'latest'			=> 'Latest',
	'oob_earliest'		=> 'Earliest OOB',
	'oob_latest'		=> 'Latest OOB',
	'oob_prefix'		=> 'Label',
	'oob_mark'			=> 'Mark',
	'oob_family'		=> 'Family',
	'ip_protocol'		=> 'Proto',
	'ip_saddr'			=> 'Source IP',
	'src_host'			=> 'Source Host',
	'ip_daddr'			=> 'Destination IP',
	'dst_host'			=> 'Destination Host',
	'ip_tos'			=> 'TOS',
	'ip_ttl'			=> 'TTL',
	'ip_totlen'			=> 'Pkt Len',
	'ip_ihl'			=> 'Head Len',
	'ip_csum'			=> 'Checksum',
	'ip_id'				=> 'IP ID',
	'ip_fragoff'		=> 'IP Offset',
	'ip6_flowlabel'		=> 'IPv6 Flow',
	'ip6_payloadlen'	=> 'IPv6 Pay Len',
	'sport'				=> 'Src Port',
	'src_service'		=> 'Src Service',
	'dport'				=> 'Dest Port',
	'dst_service'		=> 'Dest Service',
	'tcp_seq'			=> 'TCP Seq',
	'tcp_ackseq'		=> 'Ack Seq',
	'tcp_window'		=> 'Window',
	'tcp_off'			=> 'TCP Offset',
	'tcp_csum'			=> 'TCP Csum',
	'tcp_options'		=> 'Options',
	'tcp_urg'			=> 'tcp_urg',
	'tcp_urgp'			=> 'Urgent Pointer',
	'tcp_ack'			=> 'tcp_ack',
	'tcp_psh'			=> 'tcp_psh',
	'tcp_rst'			=> 'tcp_rst',
	'tcp_syn'			=> 'tcp_syn',
	'tcp_fin'			=> 'tcp_fin',
	'udp_len'			=> 'UDP Len',
	'udp_csum'			=> 'UDP Csum',
	'icmptype'			=> 'Ty',
	'icmpcode'			=> 'Co',
	'icmpechoid'		=> 'Echo ID',
	'icmpechoseq'		=> 'Echo Seq',
	'icmp_gateway'		=> 'Gateway',
	'icmp_fragmtu'		=> 'MTU',
	'icmpcsum'			=> 'ICMP Csum',
	'raw_type'			=> 'ARP Type',
	'raw_mac'			=> 'MAC String',
	'oob_protocol'		=> 'Ether Proto',
	'mac_saddr_str'		=> 'Source MAC',
	'mac_daddr_str'		=> 'Destination MAC',
	'oob_hook'			=> 'NF Hook',
	'local_time'		=> 'Local Time',
	'continent_code_s'	=> 'Src Cont Code',
	'continent_name_s'	=> 'Src Continent',
	'country_iso_code_s'	=> 'Src Cnty ISO',
	'country_name_s'		=> 'Src Country',
	'subdivision_1_iso_code_s'	=> 'Src Sub1 Code',
	'subdivision_1_name_s'		=> 'Src Sub1',
	'subdivision_2_iso_code_s'	=> 'Src Sub2 Code',
	'subdivision_2_name_s'		=> 'Src Sub2',
	'city_name_s'		=> 'Src City',
	'metro_code_s'		=> 'Src Metro',
	'time_zone_s'		=> 'Src TZ',
	'accuracy_radius_s'	=> 'Src Loc Acc',
	'registered_country_geoname_id_s'	=> 'Src Reg',
	'represented_country_geoname_id_s'	=> 'Src Rep',
	'is_anonymous_proxy_s'		=> 'Src Proxy',
	'is_satellite_provider_s'	=> 'Src Sat',
	'postal_code_s'		=> 'Src Postal',
	'latitude_s'		=> 'Src Lat',
	'longitude_s'		=> 'Src Lon',
	'is_in_european_union_s'	=> 'Src EU',
	'autonomous_system_number_s'	=> 'Src ASN',
	'autonomous_system_organization_s'	=> 'Src AS Org',
	'continent_code_d'	=> 'Dest Cont Code',
	'continent_name_d'	=> 'Dest Continent',
	'country_iso_code_d'	=> 'Dest Cnty ISO',
	'country_name_d'		=> 'Dest Country',
	'subdivision_1_iso_code_d'	=> 'Dest Sub1 Code',
	'subdivision_1_name_d'		=> 'Dest Sub1',
	'subdivision_2_iso_code_d'	=> 'Dest Sub2 Code',
	'subdivision_2_name_d'		=> 'Dest Sub2',
	'city_name_d'		=> 'Dest City',
	'metro_code_d'		=> 'Dest Metro',
	'time_zone_d'		=> 'Dest TZ',
	'accuracy_radius_d'	=> 'Dest Loc Acc',
	'registered_country_geoname_id_d'	=> 'Dest Reg',
	'represented_country_geoname_id_d'	=> 'Dest Rep',
	'is_anonymous_proxy_d'		=> 'Dest Proxy',
	'is_satellite_provider_d'	=> 'Dest Sat',
	'postal_code_d'		=> 'Dest Postal',
	'latitude_d'		=> 'Dest Lat',
	'longitude_d'		=> 'Dest Lon',
	'is_in_european_union_d'	=> 'Dest EU',
	'autonomous_system_number_d'	=> 'Dest ASN',
	'autonomous_system_organization_d'	=> 'Dest AS Org',

	'pwsniff_user'		=> 'pwsniff user',
	'pwsniff_pass'		=> 'pwsniff pass',
	'ahesp_spi'			=> 'AH/ESP SPI',
);

// The default column and sort orders are the order in which unselected 
// items will appear on the report specification form
//
// Edit at your own risk!

// default Column order
$dcolumnorder = array(
	'c_count',
	'c_oob_time_sec',
	'c_oob_time_usec',
	'c_earliest',
	'c_latest',
	'c_oob_prefix',
	'c_oob_mark',
	'c_oob_in',
	'c_oob_out',
	'c_ip_saddr',
	'c_src_host',
	'c_ip_daddr',
	'c_dst_host',
	'c_oob_family',
	'c_ip_protocol',
	'c_ip_tos',
	'c_ip_ttl',
	'c_ip_totlen',
	'c_ip_ihl',
	'c_ip_csum',
	'c_ip_id',
	'c_ip_fragoff',
	'c_ip6_flowlabel',
	'c_ip6_payloadlen',
	'c_dport',
	'c_dst_service',
	'c_sport',
	'c_src_service',
	'c_tcp_seq',
	'c_tcp_ackseq',
	'c_tcp_window',
	'c_tcp_off',
	'c_tcp_csum',
	'c_tcp_options',
	'c_tcp_urgp',
	'c_udp_len',
	'c_udp_csum',
	'c_icmptype',
	'c_icmpcode',
	'c_icmpechoid',
	'c_icmpechoseq',
	'c_icmp_gateway',
	'c_icmp_fragmtu',
	'c_icmpcsum',
	'c_sname',
	'c_id',
	'c_raw_type',
	'c_raw_mac',
	'c_oob_protocol',
	'c_mac_saddr_str',
	'c_mac_daddr_str',
	'c_oob_earliest',
	'c_oob_latest',
	'c_local_hostname',
	'c_local_time',
	'c_oob_hook',
	'c_continent_code_s',
	'c_continent_name_s',
	'c_country_iso_code_s',
	'c_country_name_s',
	'c_subdivision_1_iso_code_s',
	'c_subdivision_1_name_s',
	'c_subdivision_2_iso_code_s',
	'c_subdivision_2_name_s',
	'c_city_name_s',
	'c_metro_code_s',
	'c_time_zone_s',
	'c_accuracy_radius_s',
	'c_registered_country_geoname_id_s',
	'c_represented_country_geoname_id_s',
	'c_is_anonymous_proxy_s',
	'c_is_satellite_provider_s',
	'c_postal_code_s',
	'c_latitude_s',
	'c_longitude_s',
	'c_is_in_european_union_s',
	'c_autonomous_system_number_s',
	'c_autonomous_system_organization_s',
	'c_continent_code_d',
	'c_continent_name_d',
	'c_country_iso_code_d',
	'c_country_name_d',
	'c_subdivision_1_iso_code_d',
	'c_subdivision_1_name_d',
	'c_subdivision_2_iso_code_d',
	'c_subdivision_2_name_d',
	'c_city_name_d',
	'c_metro_code_d',
	'c_time_zone_d',
	'c_accuracy_radius_d',
	'c_registered_country_geoname_id_d',
	'c_represented_country_geoname_id_d',
	'c_is_anonymous_proxy_d',
	'c_is_satellite_provider_d',
	'c_postal_code_d',
	'c_latitude_d',
	'c_longitude_d',
	'c_is_in_european_union_d',
	'c_autonomous_system_number_d',
	'c_autonomous_system_organization_d',
	'c_pwsniff_user',
	'c_pwsniff_pass',
	'c_ahesp_spi'
);

// default sort order
$dsortorder = array(
	's_count',
	's_ip_protocol',
	's_dport',
	's_ip_saddr',
	's_ip_daddr',
	's_sport',
	's_oob_prefix',
	's_tcp_options',
	's_oob_in',
	's_oob_out',
	's_earliest',
	's_latest',
	's_oob_time_sec',
	's_oob_time_usec',
	's_oob_mark',
	's_oob_family',
	's_ip_tos',
	's_ip_ttl',
	's_ip_totlen',
	's_ip_ihl',
	's_ip_csum',
	's_ip_id',
	's_ip_fragoff',
	's_ip6_flowlabel',
	's_ip6_payloadlen',
	's_tcp_seq',
	's_tcp_ackseq',
	's_tcp_window',
	's_tcp_off',
	's_tcp_csum',
	's_tcp_urgp',
	's_udp_len',
	's_udp_csum',
	's_icmptype',
	's_icmpcode',
	's_icmpechoid',
	's_icmpechoseq',
	's_icmp_gateway',
	's_icmp_fragmtu',
	's_icmpcsum',
	's_sname',
	's_id',
	's_raw_type',
	's_raw_mac',
	's_oob_protocol',
	's_mac_saddr_str',
	's_mac_daddr_str',
	's_oob_earliest',
	's_oob_latest',
	's_local_hostname',
	's_local_time',
	's_oob_hook',
	's_continent_code_s',
	's_continent_name_s',
	's_country_iso_code_s',
	's_country_name_s',
	's_subdivision_1_iso_code_s',
	's_subdivision_1_name_s',
	's_subdivision_2_iso_code_s',
	's_subdivision_2_name_s',
	's_city_name_s',
	's_metro_code_s',
	's_time_zone_s',
	's_accuracy_radius_s',
	's_registered_country_geoname_id_s',
	's_represented_country_geoname_id_s',
	's_is_anonymous_proxy_s',
	's_is_satellite_provider_s',
	's_postal_code_s',
	's_latitude_s',
	's_longitude_s',
	's_is_in_european_union_s',
	's_autonomous_system_number_s',
	's_autonomous_system_organization_s',
	's_continent_code_d',
	's_continent_name_d',
	's_country_iso_code_d',
	's_country_name_d',
	's_subdivision_1_iso_code_d',
	's_subdivision_1_name_d',
	's_subdivision_2_iso_code_d',
	's_subdivision_2_name_d',
	's_city_name_d',
	's_metro_code_d',
	's_time_zone_d',
	's_accuracy_radius_d',
	's_registered_country_geoname_id_d',
	's_represented_country_geoname_id_d',
	's_is_anonymous_proxy_d',
	's_is_satellite_provider_d',
	's_postal_code_d',
	's_latitude_d',
	's_longitude_d',
	's_is_in_european_union_d',
	's_autonomous_system_number_d',
	's_autonomous_system_organization_d',
	's_pwsniff_user',
	's_pwsniff_pass',
	's_ahesp_spi'
);

$geoip_columns = array_flip(array(
	'continent_code_s',
	'continent_name_s',
	'country_iso_code_s',
	'country_name_s',
	'subdivision_1_iso_code_s',
	'subdivision_1_name_s',
	'subdivision_2_iso_code_s',
	'subdivision_2_name_s',
	'city_name_s',
	'metro_code_s',
	'time_zone_s',
	'accuracy_radius_s',
	'registered_country_geoname_id_s',
	'represented_country_geoname_id_s',
	'is_anonymous_proxy_s',
	'is_satellite_provider_s',
	'postal_code_s',
	'latitude_s',
	'longitude_s',
	'is_in_european_union_s',
	'autonomous_system_number_s',
	'autonomous_system_organization_s',
	'continent_code_d',
	'continent_name_d',
	'country_iso_code_d',
	'country_name_d',
	'subdivision_1_iso_code_d',
	'subdivision_1_name_d',
	'subdivision_2_iso_code_d',
	'subdivision_2_name_d',
	'city_name_d',
	'metro_code_d',
	'time_zone_d',
	'accuracy_radius_d',
	'registered_country_geoname_id_d',
	'represented_country_geoname_id_d',
	'is_anonymous_proxy_d',
	'is_satellite_provider_d',
	'postal_code_d',
	'latitude_d',
	'longitude_d',
	'is_in_european_union_d',
	'autonomous_system_number_d',
	'autonomous_system_organization_d'
));

if ($config["allow_raw_sql"]) { ;
	$dcolumnorder[] = "c_extra";
	$dsortorder[] = "s_extra";
}

// vim:set ts=4:

?>
