<?php
/*
$Id: syslog.php 727 2023-11-16 20:40:20Z bhockney $
(C) 2003-2023 by Bob Hockney <zeus@ix.netcom.com>

syslog report generation for webfwlog

Webfwlog is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
?>

<?php
	unset ($FWLOG["action"]); // don't save these
	unset ($FWLOG["page"]);
	unset ($FWLOG["orig_report"]);
	unset ($FWLOG["select_report"]);
	unset ($FWLOG["export_report"]);
	unset ($FWLOG["data_tables"]);

	$prog_params = "";
	$query = "db={$config["db"]}\n";

	if (isset($config["mysql_user"]))
		$query = $query . "mysql_user={$config["mysql_user"]}\n";
	if (isset($config["mysql_server"]))
		$query = $query . "mysql_server={$config["mysql_server"]}\n";
	if (isset($config["mysql_port"]))
		$query = $query . "mysql_port={$config["mysql_port"]}\n";
	if (isset($config["mysql_socket"]))
		$query = $query . "mysql_socket={$config["mysql_socket"]}\n";
	if (isset($config["mysql_pass"]))
		$query = $query . "mysql_pass={$config["mysql_pass"]}\n";
	if (isset($config["mysql_wfwl_db"]))
		$query = $query . "mysql_wfwl_db={$config["mysql_wfwl_db"]}\n";
	if (isset($config["pgsql_server"]))
		$query = $query . "pgsql_server={$config["pgsql_server"]}\n";
	if (isset($config["pgsql_port"]))
		$query = $query . "pgsql_port={$config["pgsql_port"]}\n";
	if (isset($config["pgsql_user"]))
		$query = $query . "pgsql_user={$config["pgsql_user"]}\n";
	if (isset($config["pgsql_pass"]))
		$query = $query . "pgsql_pass={$config["pgsql_pass"]}\n";
	if (isset($config["pgsql_db"]))
		$query = $query . "pgsql_db={$config["pgsql_db"]}\n";
	if (isset($config["pgsql_wfwl_schema"]))
		$query = $query . "pgsql_wfwl_schema={$config["pgsql_wfwl_schema"]}\n";

	if ($config["db"] == "pgsql" and $config["have_namespace"])
		$query = $query . "have_namespace=yes\n";

	if (isset($config["geoip2_locale"]))
		$query = $query . "geoip2_locale={$config["geoip2_locale"]}\n";
	if (isset($config["geoip2_file"]))
		$query = $query . "geoip2_file={$config["geoip2_file"]}\n";
	if (isset($config["geoip2_asn_file"]))
		$query = $query . "geoip2_asn_file={$config["geoip2_asn_file"]}\n";
	if (isset($config["geoip_php_lookup"]))
		$query = $query . "geoip_php_lookup={$config["geoip_php_lookup"]}\n";

    if (isset($FWLOG["w_min_date"]) and !is_numeric($FWLOG["w_min_date"]))
		$FWLOG["w_min_date"] = strtotime($FWLOG["w_min_date"]);
    if (isset($FWLOG["w_max_date"]) and !is_numeric($FWLOG["w_max_date"]))
		$FWLOG["w_max_date"] = strtotime($FWLOG["w_max_date"]);
    if (isset($FWLOG["w_min_latest"]) and !is_numeric($FWLOG["w_min_latest"]))
		$FWLOG["w_min_latest"] = strtotime($FWLOG["w_min_latest"]);
    if (isset($FWLOG["w_max_earliest"]) and !is_numeric($FWLOG["w_max_earliest"]))
		$FWLOG["w_max_earliest"] = strtotime($FWLOG["w_max_earliest"]);

    if (!isset($FWLOG["summarize"])) {
    	if (isset($FWLOG["c_count"])) {
    		if (!isset($FWLOG["c_id"])) {
    			$FWLOG["c_id"] = $FWLOG["c_count"];
			}
   			unset ($FWLOG["c_count"]);
    	}
    	if (isset($FWLOG["l_count"])) {
    		if (!isset($FWLOG["l_id"])) {
    			$FWLOG["l_id"] = $FWLOG["l_count"];
			}
   			unset ($FWLOG["l_count"]);
    	}
    	if (isset($FWLOG["c_earliest"])) {
    		if (!isset($FWLOG["c_oob_time_sec"]) and !isset($FWLOG["c_local_time"])) {
    			$FWLOG["c_local_time"] = $FWLOG["c_earliest"];
			}
   			unset ($FWLOG["c_earliest"]);
    	}
    	if (isset($FWLOG["c_latest"])) {
     		if (!isset($FWLOG["c_oob_time_sec"]) and !isset($FWLOG["c_local_time"])) {
    			$FWLOG["c_local_time"] = $FWLOG["c_latest"];
			}
   			unset ($FWLOG["c_latest"]);
    	}
    	if (isset($FWLOG["s_count"])) {
   			unset ($FWLOG["s_count"]);
    	}
    	if (isset($FWLOG["s_earliest"])) {
    		if (!isset($FWLOG["s_oob_time_sec"]) and !isset($FWLOG["s_local_time"])) {
    			$FWLOG["s_local_time"] = $FWLOG["s_earliest"];
			}
   			unset ($FWLOG["s_earliest"]);
    	}
    	if (isset($FWLOG["s_latest"])) {
     		if (!isset($FWLOG["s_oob_time_sec"]) and !isset($FWLOG["s_local_time"])) {
    			$FWLOG["s_local_time"] = $FWLOG["s_latest"];
			}
   			unset ($FWLOG["s_latest"]);
    	}
    	if (isset($FWLOG["o_earliest"])) {
   			unset ($FWLOG["o_earliest"]);
    	}
    	if (isset($FWLOG["o_latest"])) {
   			unset ($FWLOG["o_latest"]);
    	}
    }

	foreach ($FWLOG as $k => $v) {
		if ($k == "report") continue;
		$query = $query . "$k=$v\n";
	}

	if (!isset($FWLOG["c_oob_family"]) and (isset($FWLOG["c_icmptype"]) or isset($FWLOG["c_icmpcode"])
				or isset($FWLOG["c_icmpechoid"]) or isset($FWLOG["c_icmpechoseq"])))
		$query .= "c_oob_family=0\n";

	if ($config["verbosity_level"])
		$prog_params = " -" . str_repeat("v", max (1, min (6, $config["verbosity_level"])));

	if (isset($FWLOG["page_length"]) and $FWLOG["page_length"] > 0) {
		$prog_params .= " -M{$FWLOG["page_length"]}";

	if (!isset($FWLOG["start"])) {$start = 0;} else {$start = $FWLOG["start"];}
		$prog_params .= " -m$start";
	}

	$wfwl_report = tempnam("", "RPT");
	$rptfile = fopen($wfwl_report, "w");
	if (!fwrite($rptfile, "$query"))
		die("Connot create temporary file");

	fclose($rptfile);
	$prog_params .= " -r $wfwl_report";

	$filelist = "";
	$files = preg_split("/[ ]+/","{$FWLOG["syslog_file"]}");
	foreach ($files as $f) {
		if (substr_count(stripslashes("/$f"), "/.."))
			die("Cannot use '..' in filename $f");
		if (!($f == ""))
			$filelist = $filelist . " {$FWLOG["syslog_dir"]}$f";
	}

	if (isset($config['log_formats']))
		$prog_params .= " -P {$config['log_formats']}";

	$prog_params .= "$filelist";
	$prog_params .= " 2>&1";

	if (!exec("ls $filelist")) // true if return code <> 0, e.g., no such file(s)
		die("Cannot locate input file(s) $filelist");

	exec("{$config["wfwl_syslog"]} $prog_params", $result, $retval);
	unlink("$wfwl_report");

	$querytime = time() - $time;

// vim:set ts=4:

?>
